Getting Started with Scheduler Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.


Scheduler Grid

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Scheduler module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.scheduler.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-scheduler id="scheduler"></smart-scheduler>

    Host container (id matches appendTo on Smart.Scheduler):

    <div id="schedulerContainer"></div>

  5. Initialize after the module loads: define a const schedulerOptions object, then either bind with Smart('#scheduler', ...) on the semantic tag or use new Smart.Scheduler({ ...schedulerOptions, appendTo: '#schedulerContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.scheduler.js';
    
    	const schedulerOptions = {};
    
    	// Option A - semantic <smart-scheduler> with id="scheduler"
    	Smart('#scheduler', class {
    		get properties() {
    			return schedulerOptions;
    		}
    	});
    
    	// Option B - host div id="schedulerContainer"
    	// const schedulerInstance = new Smart.Scheduler({
    	// 	...schedulerOptions,
    	// 	appendTo: '#schedulerContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myScheduler = new Smart.Scheduler('#scheduler', schedulerOptions);
    	// document.body.appendChild(myScheduler);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Scheduler('#scheduler', schedulerOptions) with appendChild, and document.createElement('smart-scheduler') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Scheduler({ ...options, appendTo: '#...' }); new Smart.Scheduler('#scheduler', schedulerOptions) plus appendChild on the returned element; and document.createElement('smart-scheduler') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myScheduler = new Smart.Scheduler('#scheduler', schedulerOptions)):

	const schedulerOptions = {};
	const myScheduler = new Smart.Scheduler('#scheduler', schedulerOptions);
	document.body.appendChild(myScheduler);
	

Create with document.createElement('smart-scheduler'), assign properties (same as any custom element), then append:

	const schedulerOptions = {};
	const scheduler = document.createElement('smart-scheduler');
	Object.assign(scheduler, schedulerOptions);
	document.body.appendChild(scheduler);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.scheduler.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const schedulerOptions = {};
		const scheduler = new Smart.Scheduler({
			...schedulerOptions,
			appendTo: '#schedulerContainer'
		});
	}
	

DataSource

The dataSource property of the Smart.Scheduler allows to load an Array of Events. Each event is defined as an object with the following properties:

  • label - the label for the Event. The label should be of type 'string'.
  • dateStart - the starting date for the Event. The dateStart should be of type 'date' or 'string'.
  • dateEnd - the ending date for the Event. The end date must not be the same as the start. The dateEnd should be of type 'date' or 'string'.
  • description - the description of the Event. The description should be of type 'string'.
  • id - the unique id of the Event. The id value is applied to the DOM element that represents the event. The id should be of type 'string'.
  • class - the class of the Event. The class value is applied to the DOM element that represents the event. The class should be of type 'string'.
  • backgroundColor - a custom background color for the Event. Optional. The color should be defined as a HEX value. The backgroundColor should be ot type 'string'.
  • color - a custom color for the Event. Optional. The color should be defined as a HEX value. The color should be of type 'string'.
  • notifications - an array of objects that define the notifications for the Event. Notificaitons can appear on the same day as the event starts or before that.
    • interval - a numeric interval that indicates the number of days/weeks on which the notification will appear before the event start date.
    • type - the type of the interval. It can be 'days' or 'week'. By default it's days.
    • time - an array of numbers that indicate the hours and minutes of the date on which the notificaiton should appear.
  • allDay - a boolean property which indicates that the Event lasts all day and the Scheduler should ignore the time offset.
  • disableDrag - a boolean property that disables the abbility to drag an Event.
  • disableResize - a boolean property that disables the abbility to resize an Event.
  • repeat - a repeat object that defines the repeating settings for the Event. Optional. Repeating events have this property assigned. Here are it's attributes:
    • repeatFreq - a string that represents the repeat frequency for the event, e.g. 'daily', 'weekly', etc.
    • repeatInterval - a number that represents the repeat interval for the event.
    • repeatOn - depending on the repeatFreq the event can repeat on specific days or date. The repeatOn value can be an array of numbers which indidate the days of the week for 'weekly' repeating frequency, a number which indicates the date of the month for 'monthly' repeating frequency or a date which indicates the date of the year when repeat frequency is set to 'yearly'.
    • repeatEnd - the end condition for the repeating event. The event can end on a date or after a number of occurances. If not set the repeating event will never end.
    • exceptions - an array of objects that define the event date exceptions for the repeating event. An exception can contain a different start/end date but it's date property must be equal to an expected repeating date. Exceptions can have different backgroundColor and color. They can also be hidden via the hidden attribute.
  • These are the Event attributes that Smart.Sheduler uses. Any other attributes added to the Event objects will be preserved but not used by the element.

    Resources are assigned to the event object as key-value records. Where the key is the resource's value and value is the resource item id. Resources are described in depth in another topic on the website.

Here's an example of a Scheduler with three Events:

const today = new Date(),
    currentYear = today.getFullYear(),
    currentMonth = today.getMonth(),
    data = [
        {
            label: 'Event 1',
            dateStart: new Date(currentYear, currentMonth, 10),
            dateEnd: new Date(currentYear, currentMonth, 11)
        }, {
            label: 'Event 2',
            dateStart: new Date(currentYear, currentMonth, 11, 11, 30),
            dateEnd: new Date(currentYear, currentMonth, 11, 14, 15)
        }, {
            label: 'Event 3',
            dateStart: new Date(currentYear, currentMonth, 12, 13, 15),
            dateEnd: new Date(currentYear, currentMonth, 12, 16, 15)
        }
    ];

window.Smart('#scheduler', class {
    get properties() {
        return {
            //Properties
            view: 'week',
            dataSource: data
        };
    }
});

Demo

Scheduler

Resources

Smart.Scheduler resources can be used to assign Events to specific resources. They allow to specify the Events. Events can have one or many resources assigned to them.

Resources can have custom colors. The Scheduler can group events by one or more resources.

Resources property represents an Array of objects with the following properties:

  • label - a string that represents the label of the resource.
  • value - a string that represents the unique value of the resource by which it can be identified from the rest.
  • dataSource - an array that contains the items of the resource. Each item contains the following properties:
    • id - a number or string that acts as a unique identifier for the item.
    • label - a string that represents the label of the resource item.
    • backgroundColor - a string that represents the HEX representation of a color that will be used as the background color for the Events that have the resource item assigned.
    • color - a string that represents the HEX representation of a color that will be used as the color for the Events that have the resource item assigned.

Here's an example:

const today = new Date(),
    currentYear = today.getFullYear(),
    currentMonth = today.getMonth(),
    data = [
        {
            label: 'Event 1',
            dateStart: new Date(currentYear, currentMonth, 10),
            dateEnd: new Date(currentYear, currentMonth, 11),
            priorityId: 1
        }, {
            label: 'Event 2',
            dateStart: new Date(currentYear, currentMonth, 11, 11, 30),
            dateEnd: new Date(currentYear, currentMonth, 11, 14, 15),
            priorityId: 2
        }, {
            label: 'Event 3',
            dateStart: new Date(currentYear, currentMonth, 12, 13, 15),
            dateEnd: new Date(currentYear, currentMonth, 12, 16, 15),
            priorityId: 1
        }
    ];

const priorityData = [
    {
        label: 'Low Priority',
        id: 1,
        backgroundColor: '#1e90ff'
    }, {
        label: 'Medium Priority',
        id: 2,
        backgroundColor: '#ff9747'
    }
];

Smart('#scheduler', class {
    get properties() {
        return {
            //Properties
            view: 'week',
            dataSource: data,
            resources: [
                {
                    label: 'Priority',
                    value: 'priorityId',
                    dataSource: priorityData
                }
            ]
        };
    }
});

Here we have a single resource with identifier 'priorityId' that contains two priorities : 'low' and 'medium'. Each of them has individual color.

The resources items are assigned to the Events using their 'value' directly set to the Event objects where the 'key' is the resources value while the 'value' is the resource item id.

Demo

Scheduler Resources

Groups

Scheduler Events can be grouped by Resources. When groups property is set Events that do not have a resource assigned to them or the groups property does not include their resource will not be displayed.

The groups property accepts an array of strings which represent resource values.

Here's an example of grouping by a single resource that has two items.

Smart('#scheduler', class {
    get properties() {
        return {
            //Properties
            view: 'week',
            dataSource: data,
            resources: [
                {
                    label: 'Priority',
                    value: 'priorityId',
                    dataSource: priorityData
                }
            ],
            groups: ['priorityId']
        };
    }
});   

The timeline view of the Scheduler is separated into multiple sections for each group and the events are positioned according to their dates.

Demo

Scheduler Timeline

Smart.Scheduler is virtualized by default and does not have a limit on the groups, events or resources count.

Scheduler also allows to group events by Date in addition to Resources grouping. In order to group by date simply set the groupByDate property like so:

Smart('#scheduler', class {
    get properties() {
        return {
            //Properties
            view: 'week',
            dataSource: data,
            resources: [
                {
                    label: 'Priority',
                    value: 'priorityId',
                    dataSource: priorityData
                }
            ],
            groups: ['priorityId'],
            groupByDate: true
        };
    }
});  

Demo

Scheduler Grouping

The Events are grouped by date by separating each Date cell into the number of resource groups.

Event Editor

A Smart.Window component is available for Event editing inside the Scheduler. In order to open the editor the user simply has to double click on an event element or press the 'Enter' key when the event element is focused.

The window will appear in the middle of the Scheduler and will allow the user to modify all of the settings of the Event.

Creating new Events is also possible via the Window. When the user double clicks on a timeline cell or presses the 'Enter' key on focused cell the Event window editor will appear to create the new Event.

Here's an example:

Demo

Scheduler Window

The Scheduler window is modal so interaction with the Scheduler while the window is opened is disabled.

Event repeating options are avaialble when the "Repeat" switch button is on. The window will expand an additional panel with all repeating options allowing the user to create/customize the repeating series.

Scheduler Repeat

Clicking on the OK button will apply the editing changes to the event.

A 'confirm' window is the second type of window that can be opened inside the Smart.Scheduler. Confirm window appears when the user tries to edit a repeating event. This window prompts the user to select between editing the original repeating series or create a repeating exception from the target event. Repeating exceptions can have different start/end dates. They correspond to a specific repeating date of the original repeating series. Exceptions unlike other events cannot repeat but can be hidden via the edit window. This is useful in a scenario when, for example the user wants to create a repeating event for each day of the week but has to skip a day. Making the desired day as an exception and applying hidden will remove it form the repeating series. Repeating events and exceptions are covered in a separate topic.

Here's what the Confirm window looks like:

Scheduler Dialog

Time Zones

Smart.Scheduler allows to display additional Time zones at the same time thanks to the timeZones property which accepts an Array of strings which represent valid IANA timezone names. This allows the user to see the corresponding time for the events in multiple Time zones at once.

Here's an example of Smart.Scheduler with three Time zones visible:

const scheduler = document.querySelector('smart-scheduler');

scheduler.timeZones = [{ id: 'America/Chicago', label: 'US/Chicago' }, 'UTC'];

The default Time zone of the Smart.Scheduler is the local time zone. Setting the timeZones property displays additional time zones. In the example above the additional time zones include 'America/Chicago' and 'UTC'.

Here's what the Scheduler looks like:

Scheduler Time Zones

The default Smart.Scheduler Time zone can also be changed via the timeZone property. By default it does not have a label inside the timeline header.

Menus

Smart.Scheduler contains many popup menus with different actions. These menu's allow to the change the view/date or create/ edit an event. Here's a list of the menus that are used by the Scheduler:

  • Event Menu - appears when an event is clicked. It shows details about the event like start/end date and label. Also allows to quickly delete the event via a delete button. The delete button is available only on non-repeating events or exceptions.

    Scheduler Event Menu
  • Context Menu - appears when the user right clicks on a view cell or an event. The context menu allows to quickly create/delete and event.

    Scheduler Delete
  • Date Menu - appears when the user clicks on the Date Selector located inside the Header of the Smart.Scheduler. It allows to change the current view date.

    Scheduler Date Menu
  • View Menu - appears when the user clicks on the View Selector located inside the Header of the Smart.Scheduler. It allows to change the current view.

    Scheduler View Menu

All Scheduler menus are customizable.

Save/Load State

Smart.Scheduler utilizes the localStorage by allowing to save the current state of the events and load it again at a later point. This is usefull when the user is going to make changes to the events and wants to have a step by step history of the changes. Smart.Scheduler state represents an object that contains the current viewing date and a JSON Array of Events that were loaded to the Scheduler at the time it was saved.

The following methods are available for Smart.Scheduler state handling:

  • getState - returns an object containing the viewing date and a JSON Array of the Scheduler Events.
  • saveState - saves the current state of the Scheduler to localStorage. Requires an ID to be set to the element.
  • loadState - loads a previously saved state of the element. Accepts one argument - the state to load to. If no arguments are provided, localStorage lookup will be performed in order to find a previously saved state according to the id of the element. Requires an ID to be set to the element.
  • clearState - removes any stored state in localStorage of the element according to it's id. Requires an ID to be set to the element.
 const scheduler = document.querySelector('smart-scheduler');

//Saves the current state of the Scheduler to localStorage
scheduler.saveState();

//Reload the element to the previously saved state
scheduler.loadState();

//Clears the saved state
scheduler.clearState();

Keyboard Support

Smart.Scheduler implements the following key actions:

Key Action
Escape When dragging/resizing pressing the 'Escape' key will cancel the ongoing operation and return the target event to it's original state. The 'Escape' key can also close the Scheduler Windows and Menus if focused.
Tab Pressing Tab will change the focus to another focusable element. Smart.Scheduler has many focusable elements - the date,view selectors, the events inside the Timeline, the Timeline itself wihch allows to navigate through the cells, the Scheduler Window and it's editors, the Event/cell menu.
Arrow Up/Down/Left/Right When the Scheduler Timeline is focused these keys allow to navigate through the cells by selecting them.
Shift + Arrow Up/Down/Left/Right When the Scheduler Timeline is focused the Shift + Arrow combination allows to create a range selection of multiple cells in the direciton of the arrow pressed.
Shift + Mouse Left Click If a cell is selected, pressing Shift + Mouse Click on another cell allows to create a range selection from the initialy selected cell to the click target.
Enter Allows to open one of the Menus/Windows of the Smart.Scheduler. This can happen if an event or cell, or date/view selector is currently focused. If multiple cells are selected pressing Enter will open the Window to create a new event from the selection range.
Delete When an Event is focused this key allows to remove the Event form the Smart.Scheduler. The action can be canceled. Check the API of the element on the website for more details.
D The default shortcut key for the 'Day' view. When the view selector is focused, pressing this key will change the view to 'Day'. This shortcut can be customized. Check the API on the website for more details.
W The default shortcut key for the 'Week' view. When the view selector is focused, pressing this key will change the view to 'Week'. This shortcut can be customized. Check the API on the website for more details.
M The default shortcut key for the 'Month' view. When the view selector is focused, pressing this key will change the view to 'Month'. This shortcut can be customized. Check the API on the website for more details.
A The default shortcut key for the 'Agenda' view. When the view selector is focused, pressing this key will change the view to 'Agenda'. This shortcut can be customized. Check the API on the website for more details.
T + D The default shortcut key combination for the 'Timeline Day' view. When the view selector is focused, pressing this key combo will change the view to 'Timeline Day'. This shortcut can be customized. Check the API on the website for more details.
T + W The default shortcut key combination for the 'Timeline Week' view. When the view selector is focused, pressing this key combo will change the view to 'Timeline Week'. This shortcut can be customized. Check the API on the website for details.
T + W The default shortcut key combination for the 'Timeline Month' view. When the view selector is focused, pressing this key combo will change the view to 'Timeline Month'. This shortcut can be customized. Check the API on the website for details.

Append to the DOM:

const container = document.getElementById('scheduler-container');
container.appendChild(scheduler);
	

Remove from the DOM:

scheduler.remove();
	

Set a property:

scheduler.disabled = true;
scheduler.theme = 'dark';
	

Get a property value:

const isDisabled = scheduler.disabled;
const currentTheme = scheduler.theme;
	

Invoke a method:

scheduler.refresh();
scheduler.focus();
	

Add event listener:

scheduler.addEventListener('change', (event) => {
    console.log('change triggered:', event.detail.value);
});
	

Remove event listener:

const handleSchedulerEvent = (event) => {
    console.log('change triggered:', event.detail.value);
};

scheduler.addEventListener('change', handleSchedulerEvent);
scheduler.removeEventListener('change', handleSchedulerEvent);
	

Common Use Cases

  • Add a new event

    Programmatically create a calendar event

    scheduler.addEvent({
      label: 'Meeting',
      dateStart: new Date(2026, 4, 15, 10, 0),
      dateEnd: new Date(2026, 4, 15, 11, 0)
    });
  • Change view mode

    Switch between day, week, and month views

    scheduler.view = 'month';
  • Handle event click

    Respond when user clicks on an event

    scheduler.addEventListener('itemClick', (e) => {
      console.log('Event clicked:', e.detail.item);
    });

Troubleshooting

How do I load events from an API?
Fetch your data and assign it to scheduler.dataSource. Each event needs dateStart, dateEnd, and label properties at minimum.
How do I prevent event editing?
Set scheduler.disableEdit = true to prevent users from modifying events.
How do I change the first day of the week?
Set scheduler.firstDayOfWeek to the desired day (0 = Sunday, 1 = Monday, etc.).

Accessibility

The Scheduler component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Scheduler Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/scheduler/view-basic/App.jsx


Scheduler Grid

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import React from "react";
import ReactDOM from 'react-dom/client';
import { Scheduler } from 'smart-webcomponents-react/scheduler';

const App = () => {
	const today = new Date();
	const currentYear = today.getFullYear();
	const currentMonth = today.getMonth();
	const data = [ {
		label: 'Google AdWords Strategy',
		dateStart: new Date(currentYear, currentMonth, 10, 9, 0),
		dateEnd: new Date(currentYear, currentMonth, 11, 10, 30),
		allDay: true,
		backgroundColor: '#EA80FC'
	}, {
		label: 'New Brochures',
		dateStart: new Date(currentYear, currentMonth, 11, 11, 30),
		dateEnd: new Date(currentYear, currentMonth, 12, 14, 15),
		backgroundColor: '#FF9E80'
	}, {
		label: 'Brochure Design Review',
		dateStart: new Date(currentYear, currentMonth, 12, 13, 15),
		dateEnd: new Date(currentYear, currentMonth, 14, 16, 15),
		backgroundColor: '#039BE5'
	}, {
		label: 'Website Re-Design Plan',
		dateStart: new Date(currentYear, currentMonth, 16, 16, 45),
		dateEnd: new Date(currentYear, currentMonth, 20, 11, 15),
		backgroundColor: '#78909C'
	},
	{
		label: 'Rollout of New Website and Marketing Brochures',
		dateStart: new Date(currentYear, currentMonth, 2, 8, 15),
		dateEnd: new Date(currentYear, currentMonth, 2, 10, 45),
		backgroundColor: '#D500F9'
	}, {
		label: 'Update Sales Strategy Documents',
		dateStart: new Date(currentYear, currentMonth, 2, 12, 0),
		dateEnd: new Date(currentYear, currentMonth, 2, 13, 45),
		backgroundColor: '#689F38'
	}, {
		label: 'Non-Compete Agreements',
		dateStart: new Date(currentYear, currentMonth, 3, 8, 15),
		dateEnd: new Date(currentYear, currentMonth, 3, 9, 0),
		backgroundColor: '#9CCC65'
	}, {
		label: 'Approve Hiring of John Jeffers',
		dateStart: new Date(currentYear, currentMonth, 3, 10, 0),
		dateEnd: new Date(currentYear, currentMonth, 3, 11, 15),
		backgroundColor: '#EF6C00'
	}, {
		label: 'Update NDA Agreement',
		dateStart: new Date(currentYear, currentMonth, 3, 11, 45),
		dateEnd: new Date(currentYear, currentMonth, 3, 13, 45),
		backgroundColor: '#009688'
	}, {
		label: 'Update Employee Files with New NDA',
		dateStart: new Date(currentYear, currentMonth, 3, 14, 0),
		dateEnd: new Date(currentYear, currentMonth, 3, 16, 45),
		backgroundColor: '#FF1744'
	}, {
		label: 'Submit Questions Regarding New NDA',
		dateStart: new Date(currentYear, currentMonth, 6, 8, 0),
		dateEnd: new Date(currentYear, currentMonth, 6, 9, 30),
		backgroundColor: '#689F38'
	}, {
		label: 'Submit Signed NDA',
		dateStart: new Date(currentYear, currentMonth, 6, 12, 45),
		dateEnd: new Date(currentYear, currentMonth, 6, 14, 0),
		backgroundColor: '#76FF03'
	}, {
		label: 'Review Revenue Projections',
		dateStart: new Date(currentYear, currentMonth, 6, 17, 15),
		dateEnd: new Date(currentYear, currentMonth, 6, 18, 0),
		backgroundColor: '#F9A825'
	}, {
		label: 'Comment on Revenue Projections',
		dateStart: new Date(currentYear, currentMonth, 5, 9, 15),
		dateEnd: new Date(currentYear, currentMonth, 5, 11, 15),
		backgroundColor: '#2962FF'
	}, {
		label: 'Provide New Health Insurance Docs',
		dateStart: new Date(currentYear, currentMonth, 5, 12, 45),
		dateEnd: new Date(currentYear, currentMonth, 5, 14, 15),
		backgroundColor: '#FF6E40'
	}, {
		label: 'Review Changes to Health Insurance Coverage',
		dateStart: new Date(currentYear, currentMonth, 5, 14, 15),
		dateEnd: new Date(currentYear, currentMonth, 5, 15, 30),
		backgroundColor: '#F06292'
	}, {
		label: 'Review Training Course for any Ommissions',
		dateStart: new Date(currentYear, currentMonth, 8, 14, 0),
		dateEnd: new Date(currentYear, currentMonth, 9, 12, 0),
		backgroundColor: '#689F38'
	}, {
		label: 'Recall Rebate Form',
		dateStart: new Date(currentYear, currentMonth, 8, 12, 45),
		dateEnd: new Date(currentYear, currentMonth, 8, 13, 15),
		backgroundColor: '#4A148C'
	}, {
		label: 'Create Report on Customer Feedback',
		dateStart: new Date(currentYear, currentMonth, 9, 15, 15),
		dateEnd: new Date(currentYear, currentMonth, 9, 17, 30),
		backgroundColor: '#A1887F'
	}, {
		label: 'Review Customer Feedback Report',
		dateStart: new Date(currentYear, currentMonth, 9, 16, 15),
		dateEnd: new Date(currentYear, currentMonth, 9, 18, 30),
		backgroundColor: '#BA68C8'
	}, {
		label: 'Customer Feedback Report Analysis',
		dateStart: new Date(currentYear, currentMonth, 10, 9, 30),
		dateEnd: new Date(currentYear, currentMonth, 10, 10, 30),
		backgroundColor: '#C51162'
	}, {
		label: 'Prepare Shipping Cost Analysis Report',
		dateStart: new Date(currentYear, currentMonth, 10, 12, 30),
		dateEnd: new Date(currentYear, currentMonth, 10, 13, 30),
		backgroundColor: '#0277BD'
	}, {
		label: 'Provide Feedback on Shippers',
		dateStart: new Date(currentYear, currentMonth, 10, 14, 15),
		dateEnd: new Date(currentYear, currentMonth, 10, 16, 0),
		backgroundColor: '#8E24AA'
	}, {
		label: 'Select Preferred Shipper',
		dateStart: new Date(currentYear, currentMonth, 10, 17, 30),
		dateEnd: new Date(currentYear, currentMonth, 10, 20, 0),
		backgroundColor: '#689F38'
	}, {
		label: 'Complete Shipper Selection Form',
		dateStart: new Date(currentYear, currentMonth, 11, 8, 30),
		dateEnd: new Date(currentYear, currentMonth, 11, 10, 0),
		backgroundColor: '#388E3C'
	}, {
		label: 'Upgrade Server Hardware',
		dateStart: new Date(currentYear, currentMonth, 11, 12, 0),
		dateEnd: new Date(currentYear, currentMonth, 11, 14, 15),
		backgroundColor: '#00C853'
	}, {
		label: 'Upgrade Personal Computers',
		dateStart: new Date(currentYear, currentMonth, 11, 14, 45),
		dateEnd: new Date(currentYear, currentMonth, 11, 16, 30),
		backgroundColor: '#6200EA'
	}, {
		label: 'Upgrade Apps to Windows RT or stay with WinForms',
		dateStart: new Date(currentYear, currentMonth, 12, 10, 30),
		dateEnd: new Date(currentYear, currentMonth, 12, 13, 0),
		backgroundColor: '#66BB6A'
	}, {
		label: 'Estimate Time Required to Touch-Enable Apps',
		dateStart: new Date(currentYear, currentMonth, 12, 14, 45),
		dateEnd: new Date(currentYear, currentMonth, 12, 16, 30),
		backgroundColor: '#795548'
	}, {
		label: 'Report on Tranistion to Touch-Based Apps',
		dateStart: new Date(currentYear, currentMonth, 12, 18, 30),
		dateEnd: new Date(currentYear, currentMonth, 12, 19, 0),
		backgroundColor: '#FBC02D'
	}, {
		label: 'Submit New Website Design',
		dateStart: new Date(currentYear, currentMonth, 15, 8, 0),
		dateEnd: new Date(currentYear, currentMonth, 15, 10, 0),
		backgroundColor: '#26A69A'
	}, {
		label: 'Create Icons for Website',
		dateStart: new Date(currentYear, currentMonth, 15, 11, 30),
		dateEnd: new Date(currentYear, currentMonth, 15, 13, 15),
		backgroundColor: '#4DB6AC'
	}, {
		label: 'Create New Product Pages',
		dateStart: new Date(currentYear, currentMonth, 16, 9, 45),
		dateEnd: new Date(currentYear, currentMonth, 16, 11, 45),
		backgroundColor: '#FDD835'
	}, {
		label: 'Approve Website Launch',
		dateStart: new Date(currentYear, currentMonth, 16, 12, 0),
		dateEnd: new Date(currentYear, currentMonth, 16, 15, 15),
		backgroundColor: '#FF6E40'
	}, {
		label: 'Update Customer Shipping Profiles',
		dateStart: new Date(currentYear, currentMonth, 17, 9, 30),
		dateEnd: new Date(currentYear, currentMonth, 17, 11, 0),
		backgroundColor: '#388E3C'
	}, {
		label: 'Create New Shipping Return Labels',
		dateStart: new Date(currentYear, currentMonth, 17, 12, 45),
		dateEnd: new Date(currentYear, currentMonth, 17, 14, 0),
		backgroundColor: '#3E2723'
	}, {
		label: 'Get Design for Shipping Return Labels',
		dateStart: new Date(currentYear, currentMonth, 17, 15, 0),
		dateEnd: new Date(currentYear, currentMonth, 17, 16, 30),
		backgroundColor: '#AEEA00'
	}, {
		label: 'PSD needed for Shipping Return Labels',
		dateStart: new Date(currentYear, currentMonth, 18, 8, 30),
		dateEnd: new Date(currentYear, currentMonth, 18, 9, 15),
		backgroundColor: '#FF80AB'
	}, {
		label: 'Contact ISP and Discuss Payment Options',
		dateStart: new Date(currentYear, currentMonth, 18, 11, 30),
		dateEnd: new Date(currentYear, currentMonth, 18, 16, 0),
		backgroundColor: '#26C6DA'
	}, {
		label: 'Prepare Year-End Support Summary Report',
		dateStart: new Date(currentYear, currentMonth, 18, 17, 0),
		dateEnd: new Date(currentYear, currentMonth, 18, 20, 0),
		backgroundColor: '#E57373'
	}, {
		label: 'Review New Training Material',
		dateStart: new Date(currentYear, currentMonth, 19, 8, 0),
		dateEnd: new Date(currentYear, currentMonth, 19, 9, 15),
		backgroundColor: '#40C4FF'
	}, {
		label: 'Distribute Training Material to Support Staff',
		dateStart: new Date(currentYear, currentMonth, 19, 12, 45),
		dateEnd: new Date(currentYear, currentMonth, 19, 14, 0),
		backgroundColor: '#6D4C41'
	}, {
		label: 'Training Material Distribution Schedule',
		dateStart: new Date(currentYear, currentMonth, 19, 14, 15),
		dateEnd: new Date(currentYear, currentMonth, 19, 16, 15),
		backgroundColor: '#60BF96'
	}, {
		label: 'Approval on Converting to New HDMI Specification',
		dateStart: new Date(currentYear, currentMonth, 22, 9, 30),
		dateEnd: new Date(currentYear, currentMonth, 22, 10, 15),
		backgroundColor: '#689F38'
	}, {
		label: 'Create New Spike for Automation Server',
		dateStart: new Date(currentYear, currentMonth, 22, 10, 0),
		dateEnd: new Date(currentYear, currentMonth, 22, 12, 30),
		backgroundColor: '#BFA300'
	}, {
		label: 'Code Review - New Automation Server',
		dateStart: new Date(currentYear, currentMonth, 22, 13, 0),
		dateEnd: new Date(currentYear, currentMonth, 22, 15, 0),
		backgroundColor: '#0095FF'
	}, {
		label: 'Confirm Availability for Sales Meeting',
		dateStart: new Date(currentYear, currentMonth, 23, 10, 15),
		dateEnd: new Date(currentYear, currentMonth, 23, 15, 15),
		backgroundColor: '#B6B6B6'
	}, {
		label: 'Reschedule Sales Team Meeting',
		dateStart: new Date(currentYear, currentMonth, 23, 16, 15),
		dateEnd: new Date(currentYear, currentMonth, 23, 18, 0),
		backgroundColor: '#800037'
	}, {
		label: 'Send 2 Remotes for Giveaways',
		dateStart: new Date(currentYear, currentMonth, 24, 9, 30),
		dateEnd: new Date(currentYear, currentMonth, 24, 11, 45),
		backgroundColor: '#BF6060'
	}, {
		label: 'Discuss Product Giveaways with Management',
		dateStart: new Date(currentYear, currentMonth, 24, 12, 15),
		dateEnd: new Date(currentYear, currentMonth, 24, 16, 45),
		backgroundColor: '#BF60B2'
	}, {
		label: 'Replace Desktops on the 3rd Floor',
		dateStart: new Date(currentYear, currentMonth, 25, 9, 30),
		dateEnd: new Date(currentYear, currentMonth, 25, 10, 45),
		backgroundColor: '#BFB160'
	}, {
		label: 'Update Database with New Leads',
		dateStart: new Date(currentYear, currentMonth, 25, 12, 0),
		dateEnd: new Date(currentYear, currentMonth, 25, 14, 15),
		backgroundColor: '#BF0000'
	}, {
		label: 'Mail New Leads for Follow Up',
		dateStart: new Date(currentYear, currentMonth, 25, 14, 45),
		dateEnd: new Date(currentYear, currentMonth, 25, 15, 30),
		backgroundColor: '#7B60BF'
	}, {
		label: 'Send Territory Sales Breakdown',
		dateStart: new Date(currentYear, currentMonth, 25, 18, 0),
		dateEnd: new Date(currentYear, currentMonth, 25, 20, 0),
		backgroundColor: '#39BF00'
	}, {
		label: 'Territory Sales Breakdown Report',
		dateStart: new Date(currentYear, currentMonth, 26, 8, 45),
		dateEnd: new Date(currentYear, currentMonth, 26, 9, 45),
		backgroundColor: '#403600'
	}, {
		label: 'Report on the State of Engineering Dept',
		dateStart: new Date(currentYear, currentMonth, 26, 14, 45),
		dateEnd: new Date(currentYear, currentMonth, 26, 15, 30),
		backgroundColor: '#3D8020'
	}, {
		label: 'Staff Productivity Report',
		dateStart: new Date(currentYear, currentMonth, 26, 16, 15),
		dateEnd: new Date(currentYear, currentMonth, 26, 19, 30),
		backgroundColor: '#BF60B2'
	}];

	const view = 'day';
	const views = ['day', 'week', 'month'];
	const hourStart = 9;
	const timelineDayScale = 'halfHour';

	return (
		<div>
			<Scheduler id="scheduler" dataSource={data} view={view}
				views={views}
				hourStart={hourStart}
				timelineDayScale={timelineDayScale}></Scheduler>
		</div>
	);
}



export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Add a new event

    Programmatically create a calendar event

    scheduler.addEvent({
      label: 'Meeting',
      dateStart: new Date(2026, 4, 15, 10, 0),
      dateEnd: new Date(2026, 4, 15, 11, 0)
    });
  • Change view mode

    Switch between day, week, and month views

    scheduler.view = 'month';
  • Handle event click

    Respond when user clicks on an event

    scheduler.addEventListener('itemClick', (e) => {
      console.log('Event clicked:', e.detail.item);
    });

Troubleshooting

How do I load events from an API?
Fetch your data and assign it to scheduler.dataSource. Each event needs dateStart, dateEnd, and label properties at minimum.
How do I prevent event editing?
Set scheduler.disableEdit = true to prevent users from modifying events.
How do I change the first day of the week?
Set scheduler.firstDayOfWeek to the desired day (0 = Sunday, 1 = Monday, etc.).

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Scheduler, SchedulerProps } from 'smart-webcomponents-react/scheduler';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Scheduler component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Scheduler - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/scheduler/view-basic


Scheduler Grid

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import SchedulerModule from smart-webcomponents-angular/scheduler: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { SchedulerModule } from 'smart-webcomponents-angular/scheduler';

4 Root component (standalone)

Add SchedulerModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit, ViewEncapsulation } from '@angular/core';
import { SchedulerComponent, SchedulerEvent, SchedulerTimelineDayScale, SchedulerViewType } from 'smart-webcomponents-angular/scheduler';

import { SchedulerModule } from 'smart-webcomponents-angular/scheduler';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ SchedulerModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {
    @ViewChild('scheduler', { read: SchedulerComponent, static: false }) scheduler!: SchedulerComponent;

    dataSource: SchedulerEvent[] = (() => {
        const today = new Date(),
            currentYear = today.getFullYear(),
            currentMonth = today.getMonth();

        return [
            {
                label: 'Google AdWords Strategy',
                dateStart: new Date(currentYear, currentMonth, 10, 9, 0),
                dateEnd: new Date(currentYear, currentMonth, 11, 10, 30),
                allDay: true,
                backgroundColor: '#EA80FC'
            }, {
                label: 'New Brochures',
                dateStart: new Date(currentYear, currentMonth, 11, 11, 30),
                dateEnd: new Date(currentYear, currentMonth, 12, 14, 15),
                backgroundColor: '#FF9E80'
            }, {
                label: 'Brochure Design Review',
                dateStart: new Date(currentYear, currentMonth, 12, 13, 15),
                dateEnd: new Date(currentYear, currentMonth, 14, 16, 15),
                backgroundColor: '#039BE5'
            }, {
                label: 'Website Re-Design Plan',
                dateStart: new Date(currentYear, currentMonth, 16, 16, 45),
                dateEnd: new Date(currentYear, currentMonth, 20, 11, 15),
                backgroundColor: '#78909C'
            },
            {
                label: 'Rollout of New Website and Marketing Brochures',
                dateStart: new Date(currentYear, currentMonth, 2, 8, 15),
                dateEnd: new Date(currentYear, currentMonth, 2, 10, 45),
                backgroundColor: '#D500F9'
            }, {
                label: 'Update Sales Strategy Documents',
                dateStart: new Date(currentYear, currentMonth, 2, 12, 0),
                dateEnd: new Date(currentYear, currentMonth, 2, 13, 45),
                backgroundColor: '#689F38'
            }, {
                label: 'Non-Compete Agreements',
                dateStart: new Date(currentYear, currentMonth, 3, 8, 15),
                dateEnd: new Date(currentYear, currentMonth, 3, 9, 0),
                backgroundColor: '#9CCC65'
            }, {
                label: 'Approve Hiring of John Jeffers',
                dateStart: new Date(currentYear, currentMonth, 3, 10, 0),
                dateEnd: new Date(currentYear, currentMonth, 3, 11, 15),
                backgroundColor: '#EF6C00'
            }, {
                label: 'Update NDA Agreement',
                dateStart: new Date(currentYear, currentMonth, 3, 11, 45),
                dateEnd: new Date(currentYear, currentMonth, 3, 13, 45),
                backgroundColor: '#009688'
            }, {
                label: 'Update Employee Files with New NDA',
                dateStart: new Date(currentYear, currentMonth, 3, 14, 0),
                dateEnd: new Date(currentYear, currentMonth, 3, 16, 45),
                backgroundColor: '#FF1744'
            }, {
                label: 'Submit Questions Regarding New NDA',
                dateStart: new Date(currentYear, currentMonth, 6, 8, 0),
                dateEnd: new Date(currentYear, currentMonth, 6, 9, 30),
                backgroundColor: '#689F38'
            }, {
                label: 'Submit Signed NDA',
                dateStart: new Date(currentYear, currentMonth, 6, 12, 45),
                dateEnd: new Date(currentYear, currentMonth, 6, 14, 0),
                backgroundColor: '#76FF03'
            }, {
                label: 'Review Revenue Projections',
                dateStart: new Date(currentYear, currentMonth, 6, 17, 15),
                dateEnd: new Date(currentYear, currentMonth, 6, 18, 0),
                backgroundColor: '#F9A825'
            }, {
                label: 'Comment on Revenue Projections',
                dateStart: new Date(currentYear, currentMonth, 5, 9, 15),
                dateEnd: new Date(currentYear, currentMonth, 5, 11, 15),
                backgroundColor: '#2962FF'
            }, {
                label: 'Provide New Health Insurance Docs',
                dateStart: new Date(currentYear, currentMonth, 5, 12, 45),
                dateEnd: new Date(currentYear, currentMonth, 5, 14, 15),
                backgroundColor: '#FF6E40'
            }, {
                label: 'Review Changes to Health Insurance Coverage',
                dateStart: new Date(currentYear, currentMonth, 5, 14, 15),
                dateEnd: new Date(currentYear, currentMonth, 5, 15, 30),
                backgroundColor: '#F06292'
            }, {
                label: 'Review Training Course for any Ommissions',
                dateStart: new Date(currentYear, currentMonth, 8, 14, 0),
                dateEnd: new Date(currentYear, currentMonth, 9, 12, 0),
                backgroundColor: '#689F38'
            }, {
                label: 'Recall Rebate Form',
                dateStart: new Date(currentYear, currentMonth, 8, 12, 45),
                dateEnd: new Date(currentYear, currentMonth, 8, 13, 15),
                backgroundColor: '#4A148C'
            }, {
                label: 'Create Report on Customer Feedback',
                dateStart: new Date(currentYear, currentMonth, 9, 15, 15),
                dateEnd: new Date(currentYear, currentMonth, 9, 17, 30),
                backgroundColor: '#A1887F'
            }, {
                label: 'Review Customer Feedback Report',
                dateStart: new Date(currentYear, currentMonth, 9, 16, 15),
                dateEnd: new Date(currentYear, currentMonth, 9, 18, 30),
                backgroundColor: '#BA68C8'
            }, {
                label: 'Customer Feedback Report Analysis',
                dateStart: new Date(currentYear, currentMonth, 10, 9, 30),
                dateEnd: new Date(currentYear, currentMonth, 10, 10, 30),
                backgroundColor: '#C51162'
            }, {
                label: 'Prepare Shipping Cost Analysis Report',
                dateStart: new Date(currentYear, currentMonth, 10, 12, 30),
                dateEnd: new Date(currentYear, currentMonth, 10, 13, 30),
                backgroundColor: '#0277BD'
            }, {
                label: 'Provide Feedback on Shippers',
                dateStart: new Date(currentYear, currentMonth, 10, 14, 15),
                dateEnd: new Date(currentYear, currentMonth, 10, 16, 0),
                backgroundColor: '#8E24AA'
            }, {
                label: 'Select Preferred Shipper',
                dateStart: new Date(currentYear, currentMonth, 10, 17, 30),
                dateEnd: new Date(currentYear, currentMonth, 10, 20, 0),
                backgroundColor: '#689F38'
            }, {
                label: 'Complete Shipper Selection Form',
                dateStart: new Date(currentYear, currentMonth, 11, 8, 30),
                dateEnd: new Date(currentYear, currentMonth, 11, 10, 0),
                backgroundColor: '#388E3C'
            }, {
                label: 'Upgrade Server Hardware',
                dateStart: new Date(currentYear, currentMonth, 11, 12, 0),
                dateEnd: new Date(currentYear, currentMonth, 11, 14, 15),
                backgroundColor: '#00C853'
            }, {
                label: 'Upgrade Personal Computers',
                dateStart: new Date(currentYear, currentMonth, 11, 14, 45),
                dateEnd: new Date(currentYear, currentMonth, 11, 16, 30),
                backgroundColor: '#6200EA'
            }, {
                label: 'Upgrade Apps to Windows RT or stay with WinForms',
                dateStart: new Date(currentYear, currentMonth, 12, 10, 30),
                dateEnd: new Date(currentYear, currentMonth, 12, 13, 0),
                backgroundColor: '#66BB6A'
            }, {
                label: 'Estimate Time Required to Touch-Enable Apps',
                dateStart: new Date(currentYear, currentMonth, 12, 14, 45),
                dateEnd: new Date(currentYear, currentMonth, 12, 16, 30),
                backgroundColor: '#795548'
            }, {
                label: 'Report on Tranistion to Touch-Based Apps',
                dateStart: new Date(currentYear, currentMonth, 12, 18, 30),
                dateEnd: new Date(currentYear, currentMonth, 12, 19, 0),
                backgroundColor: '#FBC02D'
            }, {
                label: 'Submit New Website Design',
                dateStart: new Date(currentYear, currentMonth, 15, 8, 0),
                dateEnd: new Date(currentYear, currentMonth, 15, 10, 0),
                backgroundColor: '#26A69A'
            }, {
                label: 'Create Icons for Website',
                dateStart: new Date(currentYear, currentMonth, 15, 11, 30),
                dateEnd: new Date(currentYear, currentMonth, 15, 13, 15),
                backgroundColor: '#4DB6AC'
            }, {
                label: 'Create New Product Pages',
                dateStart: new Date(currentYear, currentMonth, 16, 9, 45),
                dateEnd: new Date(currentYear, currentMonth, 16, 11, 45),
                backgroundColor: '#FDD835'
            }, {
                label: 'Approve Website Launch',
                dateStart: new Date(currentYear, currentMonth, 16, 12, 0),
                dateEnd: new Date(currentYear, currentMonth, 16, 15, 15),
                backgroundColor: '#FF6E40'
            }, {
                label: 'Update Customer Shipping Profiles',
                dateStart: new Date(currentYear, currentMonth, 17, 9, 30),
                dateEnd: new Date(currentYear, currentMonth, 17, 11, 0),
                backgroundColor: '#388E3C'
            }, {
                label: 'Create New Shipping Return Labels',
                dateStart: new Date(currentYear, currentMonth, 17, 12, 45),
                dateEnd: new Date(currentYear, currentMonth, 17, 14, 0),
                backgroundColor: '#3E2723'
            }, {
                label: 'Get Design for Shipping Return Labels',
                dateStart: new Date(currentYear, currentMonth, 17, 15, 0),
                dateEnd: new Date(currentYear, currentMonth, 17, 16, 30),
                backgroundColor: '#AEEA00'
            }, {
                label: 'PSD needed for Shipping Return Labels',
                dateStart: new Date(currentYear, currentMonth, 18, 8, 30),
                dateEnd: new Date(currentYear, currentMonth, 18, 9, 15),
                backgroundColor: '#FF80AB'
            }, {
                label: 'Contact ISP and Discuss Payment Options',
                dateStart: new Date(currentYear, currentMonth, 18, 11, 30),
                dateEnd: new Date(currentYear, currentMonth, 18, 16, 0),
                backgroundColor: '#26C6DA'
            }, {
                label: 'Prepare Year-End Support Summary Report',
                dateStart: new Date(currentYear, currentMonth, 18, 17, 0),
                dateEnd: new Date(currentYear, currentMonth, 18, 20, 0),
                backgroundColor: '#E57373'
            }, {
                label: 'Review New Training Material',
                dateStart: new Date(currentYear, currentMonth, 19, 8, 0),
                dateEnd: new Date(currentYear, currentMonth, 19, 9, 15),
                backgroundColor: '#40C4FF'
            }, {
                label: 'Distribute Training Material to Support Staff',
                dateStart: new Date(currentYear, currentMonth, 19, 12, 45),
                dateEnd: new Date(currentYear, currentMonth, 19, 14, 0),
                backgroundColor: '#6D4C41'
            }, {
                label: 'Training Material Distribution Schedule',
                dateStart: new Date(currentYear, currentMonth, 19, 14, 15),
                dateEnd: new Date(currentYear, currentMonth, 19, 16, 15),
                backgroundColor: '#60BF96'
            }, {
                label: 'Approval on Converting to New HDMI Specification',
                dateStart: new Date(currentYear, currentMonth, 22, 9, 30),
                dateEnd: new Date(currentYear, currentMonth, 22, 10, 15),
                backgroundColor: '#689F38'
            }, {
                label: 'Create New Spike for Automation Server',
                dateStart: new Date(currentYear, currentMonth, 22, 10, 0),
                dateEnd: new Date(currentYear, currentMonth, 22, 12, 30),
                backgroundColor: '#BFA300'
            }, {
                label: 'Code Review - New Automation Server',
                dateStart: new Date(currentYear, currentMonth, 22, 13, 0),
                dateEnd: new Date(currentYear, currentMonth, 22, 15, 0),
                backgroundColor: '#0095FF'
            }, {
                label: 'Confirm Availability for Sales Meeting',
                dateStart: new Date(currentYear, currentMonth, 23, 10, 15),
                dateEnd: new Date(currentYear, currentMonth, 23, 15, 15),
                backgroundColor: '#B6B6B6'
            }, {
                label: 'Reschedule Sales Team Meeting',
                dateStart: new Date(currentYear, currentMonth, 23, 16, 15),
                dateEnd: new Date(currentYear, currentMonth, 23, 18, 0),
                backgroundColor: '#800037'
            }, {
                label: 'Send 2 Remotes for Giveaways',
                dateStart: new Date(currentYear, currentMonth, 24, 9, 30),
                dateEnd: new Date(currentYear, currentMonth, 24, 11, 45),
                backgroundColor: '#BF6060'
            }, {
                label: 'Discuss Product Giveaways with Management',
                dateStart: new Date(currentYear, currentMonth, 24, 12, 15),
                dateEnd: new Date(currentYear, currentMonth, 24, 16, 45),
                backgroundColor: '#BF60B2'
            }, {
                label: 'Replace Desktops on the 3rd Floor',
                dateStart: new Date(currentYear, currentMonth, 25, 9, 30),
                dateEnd: new Date(currentYear, currentMonth, 25, 10, 45),
                backgroundColor: '#BFB160'
            }, {
                label: 'Update Database with New Leads',
                dateStart: new Date(currentYear, currentMonth, 25, 12, 0),
                dateEnd: new Date(currentYear, currentMonth, 25, 14, 15),
                backgroundColor: '#BF0000'
            }, {
                label: 'Mail New Leads for Follow Up',
                dateStart: new Date(currentYear, currentMonth, 25, 14, 45),
                dateEnd: new Date(currentYear, currentMonth, 25, 15, 30),
                backgroundColor: '#7B60BF'
            }, {
                label: 'Send Territory Sales Breakdown',
                dateStart: new Date(currentYear, currentMonth, 25, 18, 0),
                dateEnd: new Date(currentYear, currentMonth, 25, 20, 0),
                backgroundColor: '#39BF00'
            }, {
                label: 'Territory Sales Breakdown Report',
                dateStart: new Date(currentYear, currentMonth, 26, 8, 45),
                dateEnd: new Date(currentYear, currentMonth, 26, 9, 45),
                backgroundColor: '#403600'
            }, {
                label: 'Report on the State of Engineering Dept',
                dateStart: new Date(currentYear, currentMonth, 26, 14, 45),
                dateEnd: new Date(currentYear, currentMonth, 26, 15, 30),
                backgroundColor: '#3D8020'
            }, {
                label: 'Staff Productivity Report',
                dateStart: new Date(currentYear, currentMonth, 26, 16, 15),
                dateEnd: new Date(currentYear, currentMonth, 26, 19, 30),
                backgroundColor: '#BF60B2'
            }
        ];
    })();

    view: SchedulerViewType = 'day';

    views: string[] = ['day', 'week', 'month'];

    hourStart: number = 9;

    timelineDayScale: SchedulerTimelineDayScale = 'halfHour';

    ngOnInit(): void {
        // onInit code.
    }

    ngAfterViewInit(): void {
        // afterViewInit code.
        this.init();
    }

    init(): void {
        // init code.
    }
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-scheduler as needed:

 <smart-scheduler #scheduler id="scheduler" [dataSource]="dataSource" [view]="view" [views]="views"
    [hourStart]="hourStart" [timelineDayScale]="timelineDayScale"></smart-scheduler>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put SchedulerModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put SchedulerModule from smart-webcomponents-angular/scheduler on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { SchedulerModule } from 'smart-webcomponents-angular/scheduler';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, SchedulerModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Add a new event

    Programmatically create a calendar event

    scheduler.addEvent({
      label: 'Meeting',
      dateStart: new Date(2026, 4, 15, 10, 0),
      dateEnd: new Date(2026, 4, 15, 11, 0)
    });
  • Change view mode

    Switch between day, week, and month views

    scheduler.view = 'month';
  • Handle event click

    Respond when user clicks on an event

    scheduler.addEventListener('itemClick', (e) => {
      console.log('Event clicked:', e.detail.item);
    });

Troubleshooting

How do I load events from an API?
Fetch your data and assign it to scheduler.dataSource. Each event needs dateStart, dateEnd, and label properties at minimum.
How do I prevent event editing?
Set scheduler.disableEdit = true to prevent users from modifying events.
How do I change the first day of the week?
Set scheduler.firstDayOfWeek to the desired day (0 = Sunday, 1 = Monday, etc.).

Accessibility

The Scheduler component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.